
import modbat.dsl._

import modbat.mbt.MBT._
import modbat.mbt.MBT

import java.util.ArrayList;


import ipasir4j.Ipasir4j;
import ipasir4j.Ipasir4j.IPASIR_RESULT;



class IPASIRModel extends Model {
  var ires : IPASIR_RESULT = IPASIR_RESULT.INDETERMINATE
  // decl. as model var for use in nextIf
  val assumed = new ArrayList[java.lang.Integer]

  var i4j : Ipasir4j = new Ipasir4j ();

  var num_variables : Int = 0
  var created_clauses : Int = 0
  var added_clauses : Int = 0
  var navailable : Int = 0
  val threshold = choose (390, 451);
  created_clauses = 0;
  num_variables = choose (10, 201);
  val num_clauses = (num_variables * threshold) / 100;
  var available = new Array [Int] (num_variables);
  navailable = num_variables;

  for (i <- 0 to num_variables-1) {
    available(i) = i+1;
  }
 
  def lit () : Int = {
    var sel: Int = choose (0, navailable);
    var l = available(sel);
    var pol: Int = choose (0,2);
    if (pol == 1) l = -l;
    return l;
  }
    
  def gcd (a1 : Int, b1 : Int) : Int = {
    var r : Int = 0;
    var a : Int = a1;
    var b : Int = b1;
    while (b > 0) {
      r = a%b;
      a = b;
      b = r;
    }
    return a;
  }
   
  "cnf" -> "unit" := {
    require(created_clauses < num_clauses)
  } label "create\nclause"
  "cnf" -> "solve" := {
    require(created_clauses >= num_clauses)
  } label "test\\lsolver"

  "unit" -> "binary" := {
    var literal : Int = lit ();

    i4j.addLiteral (literal);
  } label "choose lit"

  "unit" -> "clause" := skip weight 0.01 label "done"

  "binary" -> "ternary" := {
    var literal : Int = lit ();
    i4j.addLiteral (literal);
  } label "choose lit"

  "binary" -> "clause" := skip weight 0.1 label "done"

  "ternary" -> "rest" := {
    var literal : Int = lit ();
    i4j.addLiteral (literal);
  } label "choose lit"
  "ternary" -> "clause" := skip weight 0.25 label "done"


  "rest" -> "rest" :=  {
    var literal : Int = lit ();
    i4j.addLiteral (literal);
  } label "choose lit"

  "rest" -> "clause" := skip weight 0.80 label "done"

  "clause" -> "cnf" := {
    created_clauses = created_clauses+1;
    i4j.addLiteral (0);
  } label "add\\l clause"

  "solve" -> "sat" := {
    var pos : Int = 0;
    assumed.clear
    	  
    val i = choose (0,4);
    if ((navailable != 0) && (i == 0)) {
       do {
          pos = choose (0, navailable);
          var li = available (pos);
          if (choose (0,2) == 0) li = -li;
          i4j.assume (li);
          assumed.add(li);
       } while (choose (0,11) == 0);
     }
     ires = i4j.solve(); 
  } nextIf ({ () => ires == IPASIR_RESULT.UNSATISFIABLE } -> "unsat",
	    { () => ires == IPASIR_RESULT.INDETERMINATE } -> "inc")
              
  "sat" -> "inc" := {
    var i = (choose (0, num_variables));
    while (i > 0) {
      i = i-1;
      var li = choose (1, 2*num_variables);
      if (choose (0,2) == 0) li = -li;
      i4j.value(li);
    }
  } label "check\\lassignment"

  "unsat" -> "inc" := {
    val nassumed = assumed.size
    if (nassumed > 0) {
      var i = choose (0, 3*nassumed / 2);
      while (i > 0) {
        i = i - 1;
        i4j.failed ( assumed.get(choose (0, nassumed)));
      }
    }
  } label "check\\lassumption"

  "inc" -> "end" := skip weight 0.1 label "exit"

  "inc" -> "cnf" := {
    var oldavailable : Int = 0;
    var newvars : Int = 0;
    	    
    newvars = choose (0, 51);
    if (newvars != 0) {
      oldavailable = navailable;
      navailable = navailable + newvars;
      var tmp : Array [Int] = new Array [Int] (oldavailable);
    	    
      for (i <- 0 to oldavailable-1) {
        tmp (i) = available (i);
      }
      available = new Array [Int] (navailable);
  	      
      for (i <- 0 to oldavailable - 1 ) {
        available (i) = tmp (i);
      }
      for (i <- 0 to newvars-1) 
        available (oldavailable+i) = num_variables+i+1;
    	num_variables = num_variables + newvars;
      }
  } label "add\\l clauses"
}
